unit schVentasTerminadasServer_Intf;

interface

uses
  Classes, DB, SysUtils, uROClasses, uDADataTable, uDABusinessProcessor, FmtBCD, uROXMLIntf, schVentasTerminadasClient_Intf;

const
  { Delta rules ids 
       Feel free to change them to something more human readable
       but make sure they are unique in the context of your application }
  RID_VentasTerminadasCrossTabDelta = '{450CE6EB-71EE-4A59-9D2A-558F4D5346A3}';
  RID_VentasTerminadasDelta = '{05A89678-2248-4B09-9BEC-354E07FD2CE5}';

type
  { IVentasTerminadasCrossTabDelta }
  IVentasTerminadasCrossTabDelta = interface(IVentasTerminadasCrossTab)
  ['{450CE6EB-71EE-4A59-9D2A-558F4D5346A3}']
    { Property getters and setters }

    { Properties }
  end;

  { TVentasTerminadasCrossTabBusinessProcessorRules }
  TVentasTerminadasCrossTabBusinessProcessorRules = class(TDABusinessProcessorRules, IVentasTerminadasCrossTab, IVentasTerminadasCrossTabDelta)
  private
  protected
    { Property getters and setters }

    { Properties }

  public
    constructor Create(aBusinessProcessor: TDABusinessProcessor); override;
    destructor Destroy; override;

  end;

  { IVentasTerminadasDelta }
  IVentasTerminadasDelta = interface(IVentasTerminadas)
  ['{05A89678-2248-4B09-9BEC-354E07FD2CE5}']
    { Property getters and setters }
    function GetOldNUMINFValue : String;
    function GetOldCLAVE1Value : TBcd;
    function GetOldCLAVE2Value : Integer;
    function GetOldCLAVE3Value : Integer;
    function GetOldFECHAValue : DateTime;
    function GetOldDIAValue : Integer;
    function GetOldDIASEMANAValue : WideString;
    function GetOldMESValue : WideString;
    function GetOldANOValue : Integer;
    function GetOldCENTROValue : String;
    function GetOldVENDEDORValue : String;
    function GetOldNUMTALONValue : String;
    function GetOldCODIGOValue : String;
    function GetOldPRODUCTOValue : String;
    function GetOldGRUPOPRODUCTOValue : String;
    function GetOldTIPOPRODUCTOValue : String;
    function GetOldCOLECCIONValue : String;
    function GetOldCOLORValue : String;
    function GetOldTALLAValue : String;
    function GetOldTALLA38Value : TBcd;
    function GetOldTALLA40Value : TBcd;
    function GetOldTALLA42Value : TBcd;
    function GetOldTALLA44Value : TBcd;
    function GetOldTALLA46Value : TBcd;
    function GetOldTALLA48Value : TBcd;
    function GetOldVTATERMDEVValue : TBcd;
    function GetOldVTAFINALRESCValue : TBcd;
    function GetOldVENTASValue : TBcd;
    function GetOldDEVOLUCIONESValue : TBcd;
    function GetOldTOTALValue : TBcd;
    function GetOldVALTERMDEVValue : TBcd;
    function GetOldVALFINALRESCValue : TBcd;
    function GetOldVALVENValue : TBcd;
    function GetOldVALDEVValue : TBcd;
    function GetOldVALTOTValue : TBcd;

    { Properties }
    property OldNUMINF : String read GetOldNUMINFValue;
    property OldCLAVE1 : TBcd read GetOldCLAVE1Value;
    property OldCLAVE2 : Integer read GetOldCLAVE2Value;
    property OldCLAVE3 : Integer read GetOldCLAVE3Value;
    property OldFECHA : DateTime read GetOldFECHAValue;
    property OldDIA : Integer read GetOldDIAValue;
    property OldDIASEMANA : WideString read GetOldDIASEMANAValue;
    property OldMES : WideString read GetOldMESValue;
    property OldANO : Integer read GetOldANOValue;
    property OldCENTRO : String read GetOldCENTROValue;
    property OldVENDEDOR : String read GetOldVENDEDORValue;
    property OldNUMTALON : String read GetOldNUMTALONValue;
    property OldCODIGO : String read GetOldCODIGOValue;
    property OldPRODUCTO : String read GetOldPRODUCTOValue;
    property OldGRUPOPRODUCTO : String read GetOldGRUPOPRODUCTOValue;
    property OldTIPOPRODUCTO : String read GetOldTIPOPRODUCTOValue;
    property OldCOLECCION : String read GetOldCOLECCIONValue;
    property OldCOLOR : String read GetOldCOLORValue;
    property OldTALLA : String read GetOldTALLAValue;
    property OldTALLA38 : TBcd read GetOldTALLA38Value;
    property OldTALLA40 : TBcd read GetOldTALLA40Value;
    property OldTALLA42 : TBcd read GetOldTALLA42Value;
    property OldTALLA44 : TBcd read GetOldTALLA44Value;
    property OldTALLA46 : TBcd read GetOldTALLA46Value;
    property OldTALLA48 : TBcd read GetOldTALLA48Value;
    property OldVTATERMDEV : TBcd read GetOldVTATERMDEVValue;
    property OldVTAFINALRESC : TBcd read GetOldVTAFINALRESCValue;
    property OldVENTAS : TBcd read GetOldVENTASValue;
    property OldDEVOLUCIONES : TBcd read GetOldDEVOLUCIONESValue;
    property OldTOTAL : TBcd read GetOldTOTALValue;
    property OldVALTERMDEV : TBcd read GetOldVALTERMDEVValue;
    property OldVALFINALRESC : TBcd read GetOldVALFINALRESCValue;
    property OldVALVEN : TBcd read GetOldVALVENValue;
    property OldVALDEV : TBcd read GetOldVALDEVValue;
    property OldVALTOT : TBcd read GetOldVALTOTValue;
  end;

  { TVentasTerminadasBusinessProcessorRules }
  TVentasTerminadasBusinessProcessorRules = class(TDABusinessProcessorRules, IVentasTerminadas, IVentasTerminadasDelta)
  private
  protected
    { Property getters and setters }
    function GetNUMINFValue: String; virtual;
    function GetNUMINFIsNull: Boolean; virtual;
    function GetOldNUMINFValue: String; virtual;
    function GetOldNUMINFIsNull: Boolean; virtual;
    procedure SetNUMINFValue(const aValue: String); virtual;
    procedure SetNUMINFIsNull(const aValue: Boolean); virtual;
    function GetCLAVE1Value: TBcd; virtual;
    function GetCLAVE1IsNull: Boolean; virtual;
    function GetOldCLAVE1Value: TBcd; virtual;
    function GetOldCLAVE1IsNull: Boolean; virtual;
    procedure SetCLAVE1Value(const aValue: TBcd); virtual;
    procedure SetCLAVE1IsNull(const aValue: Boolean); virtual;
    function GetCLAVE2Value: Integer; virtual;
    function GetCLAVE2IsNull: Boolean; virtual;
    function GetOldCLAVE2Value: Integer; virtual;
    function GetOldCLAVE2IsNull: Boolean; virtual;
    procedure SetCLAVE2Value(const aValue: Integer); virtual;
    procedure SetCLAVE2IsNull(const aValue: Boolean); virtual;
    function GetCLAVE3Value: Integer; virtual;
    function GetCLAVE3IsNull: Boolean; virtual;
    function GetOldCLAVE3Value: Integer; virtual;
    function GetOldCLAVE3IsNull: Boolean; virtual;
    procedure SetCLAVE3Value(const aValue: Integer); virtual;
    procedure SetCLAVE3IsNull(const aValue: Boolean); virtual;
    function GetFECHAValue: DateTime; virtual;
    function GetFECHAIsNull: Boolean; virtual;
    function GetOldFECHAValue: DateTime; virtual;
    function GetOldFECHAIsNull: Boolean; virtual;
    procedure SetFECHAValue(const aValue: DateTime); virtual;
    procedure SetFECHAIsNull(const aValue: Boolean); virtual;
    function GetDIAValue: Integer; virtual;
    function GetDIAIsNull: Boolean; virtual;
    function GetOldDIAValue: Integer; virtual;
    function GetOldDIAIsNull: Boolean; virtual;
    procedure SetDIAValue(const aValue: Integer); virtual;
    procedure SetDIAIsNull(const aValue: Boolean); virtual;
    function GetDIASEMANAValue: WideString; virtual;
    function GetDIASEMANAIsNull: Boolean; virtual;
    function GetOldDIASEMANAValue: WideString; virtual;
    function GetOldDIASEMANAIsNull: Boolean; virtual;
    procedure SetDIASEMANAValue(const aValue: WideString); virtual;
    procedure SetDIASEMANAIsNull(const aValue: Boolean); virtual;
    function GetMESValue: WideString; virtual;
    function GetMESIsNull: Boolean; virtual;
    function GetOldMESValue: WideString; virtual;
    function GetOldMESIsNull: Boolean; virtual;
    procedure SetMESValue(const aValue: WideString); virtual;
    procedure SetMESIsNull(const aValue: Boolean); virtual;
    function GetANOValue: Integer; virtual;
    function GetANOIsNull: Boolean; virtual;
    function GetOldANOValue: Integer; virtual;
    function GetOldANOIsNull: Boolean; virtual;
    procedure SetANOValue(const aValue: Integer); virtual;
    procedure SetANOIsNull(const aValue: Boolean); virtual;
    function GetCENTROValue: String; virtual;
    function GetCENTROIsNull: Boolean; virtual;
    function GetOldCENTROValue: String; virtual;
    function GetOldCENTROIsNull: Boolean; virtual;
    procedure SetCENTROValue(const aValue: String); virtual;
    procedure SetCENTROIsNull(const aValue: Boolean); virtual;
    function GetVENDEDORValue: String; virtual;
    function GetVENDEDORIsNull: Boolean; virtual;
    function GetOldVENDEDORValue: String; virtual;
    function GetOldVENDEDORIsNull: Boolean; virtual;
    procedure SetVENDEDORValue(const aValue: String); virtual;
    procedure SetVENDEDORIsNull(const aValue: Boolean); virtual;
    function GetNUMTALONValue: String; virtual;
    function GetNUMTALONIsNull: Boolean; virtual;
    function GetOldNUMTALONValue: String; virtual;
    function GetOldNUMTALONIsNull: Boolean; virtual;
    procedure SetNUMTALONValue(const aValue: String); virtual;
    procedure SetNUMTALONIsNull(const aValue: Boolean); virtual;
    function GetCODIGOValue: String; virtual;
    function GetCODIGOIsNull: Boolean; virtual;
    function GetOldCODIGOValue: String; virtual;
    function GetOldCODIGOIsNull: Boolean; virtual;
    procedure SetCODIGOValue(const aValue: String); virtual;
    procedure SetCODIGOIsNull(const aValue: Boolean); virtual;
    function GetPRODUCTOValue: String; virtual;
    function GetPRODUCTOIsNull: Boolean; virtual;
    function GetOldPRODUCTOValue: String; virtual;
    function GetOldPRODUCTOIsNull: Boolean; virtual;
    procedure SetPRODUCTOValue(const aValue: String); virtual;
    procedure SetPRODUCTOIsNull(const aValue: Boolean); virtual;
    function GetGRUPOPRODUCTOValue: String; virtual;
    function GetGRUPOPRODUCTOIsNull: Boolean; virtual;
    function GetOldGRUPOPRODUCTOValue: String; virtual;
    function GetOldGRUPOPRODUCTOIsNull: Boolean; virtual;
    procedure SetGRUPOPRODUCTOValue(const aValue: String); virtual;
    procedure SetGRUPOPRODUCTOIsNull(const aValue: Boolean); virtual;
    function GetTIPOPRODUCTOValue: String; virtual;
    function GetTIPOPRODUCTOIsNull: Boolean; virtual;
    function GetOldTIPOPRODUCTOValue: String; virtual;
    function GetOldTIPOPRODUCTOIsNull: Boolean; virtual;
    procedure SetTIPOPRODUCTOValue(const aValue: String); virtual;
    procedure SetTIPOPRODUCTOIsNull(const aValue: Boolean); virtual;
    function GetCOLECCIONValue: String; virtual;
    function GetCOLECCIONIsNull: Boolean; virtual;
    function GetOldCOLECCIONValue: String; virtual;
    function GetOldCOLECCIONIsNull: Boolean; virtual;
    procedure SetCOLECCIONValue(const aValue: String); virtual;
    procedure SetCOLECCIONIsNull(const aValue: Boolean); virtual;
    function GetCOLORValue: String; virtual;
    function GetCOLORIsNull: Boolean; virtual;
    function GetOldCOLORValue: String; virtual;
    function GetOldCOLORIsNull: Boolean; virtual;
    procedure SetCOLORValue(const aValue: String); virtual;
    procedure SetCOLORIsNull(const aValue: Boolean); virtual;
    function GetTALLAValue: String; virtual;
    function GetTALLAIsNull: Boolean; virtual;
    function GetOldTALLAValue: String; virtual;
    function GetOldTALLAIsNull: Boolean; virtual;
    procedure SetTALLAValue(const aValue: String); virtual;
    procedure SetTALLAIsNull(const aValue: Boolean); virtual;
    function GetTALLA38Value: TBcd; virtual;
    function GetTALLA38IsNull: Boolean; virtual;
    function GetOldTALLA38Value: TBcd; virtual;
    function GetOldTALLA38IsNull: Boolean; virtual;
    procedure SetTALLA38Value(const aValue: TBcd); virtual;
    procedure SetTALLA38IsNull(const aValue: Boolean); virtual;
    function GetTALLA40Value: TBcd; virtual;
    function GetTALLA40IsNull: Boolean; virtual;
    function GetOldTALLA40Value: TBcd; virtual;
    function GetOldTALLA40IsNull: Boolean; virtual;
    procedure SetTALLA40Value(const aValue: TBcd); virtual;
    procedure SetTALLA40IsNull(const aValue: Boolean); virtual;
    function GetTALLA42Value: TBcd; virtual;
    function GetTALLA42IsNull: Boolean; virtual;
    function GetOldTALLA42Value: TBcd; virtual;
    function GetOldTALLA42IsNull: Boolean; virtual;
    procedure SetTALLA42Value(const aValue: TBcd); virtual;
    procedure SetTALLA42IsNull(const aValue: Boolean); virtual;
    function GetTALLA44Value: TBcd; virtual;
    function GetTALLA44IsNull: Boolean; virtual;
    function GetOldTALLA44Value: TBcd; virtual;
    function GetOldTALLA44IsNull: Boolean; virtual;
    procedure SetTALLA44Value(const aValue: TBcd); virtual;
    procedure SetTALLA44IsNull(const aValue: Boolean); virtual;
    function GetTALLA46Value: TBcd; virtual;
    function GetTALLA46IsNull: Boolean; virtual;
    function GetOldTALLA46Value: TBcd; virtual;
    function GetOldTALLA46IsNull: Boolean; virtual;
    procedure SetTALLA46Value(const aValue: TBcd); virtual;
    procedure SetTALLA46IsNull(const aValue: Boolean); virtual;
    function GetTALLA48Value: TBcd; virtual;
    function GetTALLA48IsNull: Boolean; virtual;
    function GetOldTALLA48Value: TBcd; virtual;
    function GetOldTALLA48IsNull: Boolean; virtual;
    procedure SetTALLA48Value(const aValue: TBcd); virtual;
    procedure SetTALLA48IsNull(const aValue: Boolean); virtual;
    function GetVTATERMDEVValue: TBcd; virtual;
    function GetVTATERMDEVIsNull: Boolean; virtual;
    function GetOldVTATERMDEVValue: TBcd; virtual;
    function GetOldVTATERMDEVIsNull: Boolean; virtual;
    procedure SetVTATERMDEVValue(const aValue: TBcd); virtual;
    procedure SetVTATERMDEVIsNull(const aValue: Boolean); virtual;
    function GetVTAFINALRESCValue: TBcd; virtual;
    function GetVTAFINALRESCIsNull: Boolean; virtual;
    function GetOldVTAFINALRESCValue: TBcd; virtual;
    function GetOldVTAFINALRESCIsNull: Boolean; virtual;
    procedure SetVTAFINALRESCValue(const aValue: TBcd); virtual;
    procedure SetVTAFINALRESCIsNull(const aValue: Boolean); virtual;
    function GetVENTASValue: TBcd; virtual;
    function GetVENTASIsNull: Boolean; virtual;
    function GetOldVENTASValue: TBcd; virtual;
    function GetOldVENTASIsNull: Boolean; virtual;
    procedure SetVENTASValue(const aValue: TBcd); virtual;
    procedure SetVENTASIsNull(const aValue: Boolean); virtual;
    function GetDEVOLUCIONESValue: TBcd; virtual;
    function GetDEVOLUCIONESIsNull: Boolean; virtual;
    function GetOldDEVOLUCIONESValue: TBcd; virtual;
    function GetOldDEVOLUCIONESIsNull: Boolean; virtual;
    procedure SetDEVOLUCIONESValue(const aValue: TBcd); virtual;
    procedure SetDEVOLUCIONESIsNull(const aValue: Boolean); virtual;
    function GetTOTALValue: TBcd; virtual;
    function GetTOTALIsNull: Boolean; virtual;
    function GetOldTOTALValue: TBcd; virtual;
    function GetOldTOTALIsNull: Boolean; virtual;
    procedure SetTOTALValue(const aValue: TBcd); virtual;
    procedure SetTOTALIsNull(const aValue: Boolean); virtual;
    function GetVALTERMDEVValue: TBcd; virtual;
    function GetVALTERMDEVIsNull: Boolean; virtual;
    function GetOldVALTERMDEVValue: TBcd; virtual;
    function GetOldVALTERMDEVIsNull: Boolean; virtual;
    procedure SetVALTERMDEVValue(const aValue: TBcd); virtual;
    procedure SetVALTERMDEVIsNull(const aValue: Boolean); virtual;
    function GetVALFINALRESCValue: TBcd; virtual;
    function GetVALFINALRESCIsNull: Boolean; virtual;
    function GetOldVALFINALRESCValue: TBcd; virtual;
    function GetOldVALFINALRESCIsNull: Boolean; virtual;
    procedure SetVALFINALRESCValue(const aValue: TBcd); virtual;
    procedure SetVALFINALRESCIsNull(const aValue: Boolean); virtual;
    function GetVALVENValue: TBcd; virtual;
    function GetVALVENIsNull: Boolean; virtual;
    function GetOldVALVENValue: TBcd; virtual;
    function GetOldVALVENIsNull: Boolean; virtual;
    procedure SetVALVENValue(const aValue: TBcd); virtual;
    procedure SetVALVENIsNull(const aValue: Boolean); virtual;
    function GetVALDEVValue: TBcd; virtual;
    function GetVALDEVIsNull: Boolean; virtual;
    function GetOldVALDEVValue: TBcd; virtual;
    function GetOldVALDEVIsNull: Boolean; virtual;
    procedure SetVALDEVValue(const aValue: TBcd); virtual;
    procedure SetVALDEVIsNull(const aValue: Boolean); virtual;
    function GetVALTOTValue: TBcd; virtual;
    function GetVALTOTIsNull: Boolean; virtual;
    function GetOldVALTOTValue: TBcd; virtual;
    function GetOldVALTOTIsNull: Boolean; virtual;
    procedure SetVALTOTValue(const aValue: TBcd); virtual;
    procedure SetVALTOTIsNull(const aValue: Boolean); virtual;

    { Properties }
    property NUMINF : String read GetNUMINFValue write SetNUMINFValue;
    property NUMINFIsNull : Boolean read GetNUMINFIsNull write SetNUMINFIsNull;
    property OldNUMINF : String read GetOldNUMINFValue;
    property OldNUMINFIsNull : Boolean read GetOldNUMINFIsNull;
    property CLAVE1 : TBcd read GetCLAVE1Value write SetCLAVE1Value;
    property CLAVE1IsNull : Boolean read GetCLAVE1IsNull write SetCLAVE1IsNull;
    property OldCLAVE1 : TBcd read GetOldCLAVE1Value;
    property OldCLAVE1IsNull : Boolean read GetOldCLAVE1IsNull;
    property CLAVE2 : Integer read GetCLAVE2Value write SetCLAVE2Value;
    property CLAVE2IsNull : Boolean read GetCLAVE2IsNull write SetCLAVE2IsNull;
    property OldCLAVE2 : Integer read GetOldCLAVE2Value;
    property OldCLAVE2IsNull : Boolean read GetOldCLAVE2IsNull;
    property CLAVE3 : Integer read GetCLAVE3Value write SetCLAVE3Value;
    property CLAVE3IsNull : Boolean read GetCLAVE3IsNull write SetCLAVE3IsNull;
    property OldCLAVE3 : Integer read GetOldCLAVE3Value;
    property OldCLAVE3IsNull : Boolean read GetOldCLAVE3IsNull;
    property FECHA : DateTime read GetFECHAValue write SetFECHAValue;
    property FECHAIsNull : Boolean read GetFECHAIsNull write SetFECHAIsNull;
    property OldFECHA : DateTime read GetOldFECHAValue;
    property OldFECHAIsNull : Boolean read GetOldFECHAIsNull;
    property DIA : Integer read GetDIAValue write SetDIAValue;
    property DIAIsNull : Boolean read GetDIAIsNull write SetDIAIsNull;
    property OldDIA : Integer read GetOldDIAValue;
    property OldDIAIsNull : Boolean read GetOldDIAIsNull;
    property DIASEMANA : WideString read GetDIASEMANAValue write SetDIASEMANAValue;
    property DIASEMANAIsNull : Boolean read GetDIASEMANAIsNull write SetDIASEMANAIsNull;
    property OldDIASEMANA : WideString read GetOldDIASEMANAValue;
    property OldDIASEMANAIsNull : Boolean read GetOldDIASEMANAIsNull;
    property MES : WideString read GetMESValue write SetMESValue;
    property MESIsNull : Boolean read GetMESIsNull write SetMESIsNull;
    property OldMES : WideString read GetOldMESValue;
    property OldMESIsNull : Boolean read GetOldMESIsNull;
    property ANO : Integer read GetANOValue write SetANOValue;
    property ANOIsNull : Boolean read GetANOIsNull write SetANOIsNull;
    property OldANO : Integer read GetOldANOValue;
    property OldANOIsNull : Boolean read GetOldANOIsNull;
    property CENTRO : String read GetCENTROValue write SetCENTROValue;
    property CENTROIsNull : Boolean read GetCENTROIsNull write SetCENTROIsNull;
    property OldCENTRO : String read GetOldCENTROValue;
    property OldCENTROIsNull : Boolean read GetOldCENTROIsNull;
    property VENDEDOR : String read GetVENDEDORValue write SetVENDEDORValue;
    property VENDEDORIsNull : Boolean read GetVENDEDORIsNull write SetVENDEDORIsNull;
    property OldVENDEDOR : String read GetOldVENDEDORValue;
    property OldVENDEDORIsNull : Boolean read GetOldVENDEDORIsNull;
    property NUMTALON : String read GetNUMTALONValue write SetNUMTALONValue;
    property NUMTALONIsNull : Boolean read GetNUMTALONIsNull write SetNUMTALONIsNull;
    property OldNUMTALON : String read GetOldNUMTALONValue;
    property OldNUMTALONIsNull : Boolean read GetOldNUMTALONIsNull;
    property CODIGO : String read GetCODIGOValue write SetCODIGOValue;
    property CODIGOIsNull : Boolean read GetCODIGOIsNull write SetCODIGOIsNull;
    property OldCODIGO : String read GetOldCODIGOValue;
    property OldCODIGOIsNull : Boolean read GetOldCODIGOIsNull;
    property PRODUCTO : String read GetPRODUCTOValue write SetPRODUCTOValue;
    property PRODUCTOIsNull : Boolean read GetPRODUCTOIsNull write SetPRODUCTOIsNull;
    property OldPRODUCTO : String read GetOldPRODUCTOValue;
    property OldPRODUCTOIsNull : Boolean read GetOldPRODUCTOIsNull;
    property GRUPOPRODUCTO : String read GetGRUPOPRODUCTOValue write SetGRUPOPRODUCTOValue;
    property GRUPOPRODUCTOIsNull : Boolean read GetGRUPOPRODUCTOIsNull write SetGRUPOPRODUCTOIsNull;
    property OldGRUPOPRODUCTO : String read GetOldGRUPOPRODUCTOValue;
    property OldGRUPOPRODUCTOIsNull : Boolean read GetOldGRUPOPRODUCTOIsNull;
    property TIPOPRODUCTO : String read GetTIPOPRODUCTOValue write SetTIPOPRODUCTOValue;
    property TIPOPRODUCTOIsNull : Boolean read GetTIPOPRODUCTOIsNull write SetTIPOPRODUCTOIsNull;
    property OldTIPOPRODUCTO : String read GetOldTIPOPRODUCTOValue;
    property OldTIPOPRODUCTOIsNull : Boolean read GetOldTIPOPRODUCTOIsNull;
    property COLECCION : String read GetCOLECCIONValue write SetCOLECCIONValue;
    property COLECCIONIsNull : Boolean read GetCOLECCIONIsNull write SetCOLECCIONIsNull;
    property OldCOLECCION : String read GetOldCOLECCIONValue;
    property OldCOLECCIONIsNull : Boolean read GetOldCOLECCIONIsNull;
    property COLOR : String read GetCOLORValue write SetCOLORValue;
    property COLORIsNull : Boolean read GetCOLORIsNull write SetCOLORIsNull;
    property OldCOLOR : String read GetOldCOLORValue;
    property OldCOLORIsNull : Boolean read GetOldCOLORIsNull;
    property TALLA : String read GetTALLAValue write SetTALLAValue;
    property TALLAIsNull : Boolean read GetTALLAIsNull write SetTALLAIsNull;
    property OldTALLA : String read GetOldTALLAValue;
    property OldTALLAIsNull : Boolean read GetOldTALLAIsNull;
    property TALLA38 : TBcd read GetTALLA38Value write SetTALLA38Value;
    property TALLA38IsNull : Boolean read GetTALLA38IsNull write SetTALLA38IsNull;
    property OldTALLA38 : TBcd read GetOldTALLA38Value;
    property OldTALLA38IsNull : Boolean read GetOldTALLA38IsNull;
    property TALLA40 : TBcd read GetTALLA40Value write SetTALLA40Value;
    property TALLA40IsNull : Boolean read GetTALLA40IsNull write SetTALLA40IsNull;
    property OldTALLA40 : TBcd read GetOldTALLA40Value;
    property OldTALLA40IsNull : Boolean read GetOldTALLA40IsNull;
    property TALLA42 : TBcd read GetTALLA42Value write SetTALLA42Value;
    property TALLA42IsNull : Boolean read GetTALLA42IsNull write SetTALLA42IsNull;
    property OldTALLA42 : TBcd read GetOldTALLA42Value;
    property OldTALLA42IsNull : Boolean read GetOldTALLA42IsNull;
    property TALLA44 : TBcd read GetTALLA44Value write SetTALLA44Value;
    property TALLA44IsNull : Boolean read GetTALLA44IsNull write SetTALLA44IsNull;
    property OldTALLA44 : TBcd read GetOldTALLA44Value;
    property OldTALLA44IsNull : Boolean read GetOldTALLA44IsNull;
    property TALLA46 : TBcd read GetTALLA46Value write SetTALLA46Value;
    property TALLA46IsNull : Boolean read GetTALLA46IsNull write SetTALLA46IsNull;
    property OldTALLA46 : TBcd read GetOldTALLA46Value;
    property OldTALLA46IsNull : Boolean read GetOldTALLA46IsNull;
    property TALLA48 : TBcd read GetTALLA48Value write SetTALLA48Value;
    property TALLA48IsNull : Boolean read GetTALLA48IsNull write SetTALLA48IsNull;
    property OldTALLA48 : TBcd read GetOldTALLA48Value;
    property OldTALLA48IsNull : Boolean read GetOldTALLA48IsNull;
    property VTATERMDEV : TBcd read GetVTATERMDEVValue write SetVTATERMDEVValue;
    property VTATERMDEVIsNull : Boolean read GetVTATERMDEVIsNull write SetVTATERMDEVIsNull;
    property OldVTATERMDEV : TBcd read GetOldVTATERMDEVValue;
    property OldVTATERMDEVIsNull : Boolean read GetOldVTATERMDEVIsNull;
    property VTAFINALRESC : TBcd read GetVTAFINALRESCValue write SetVTAFINALRESCValue;
    property VTAFINALRESCIsNull : Boolean read GetVTAFINALRESCIsNull write SetVTAFINALRESCIsNull;
    property OldVTAFINALRESC : TBcd read GetOldVTAFINALRESCValue;
    property OldVTAFINALRESCIsNull : Boolean read GetOldVTAFINALRESCIsNull;
    property VENTAS : TBcd read GetVENTASValue write SetVENTASValue;
    property VENTASIsNull : Boolean read GetVENTASIsNull write SetVENTASIsNull;
    property OldVENTAS : TBcd read GetOldVENTASValue;
    property OldVENTASIsNull : Boolean read GetOldVENTASIsNull;
    property DEVOLUCIONES : TBcd read GetDEVOLUCIONESValue write SetDEVOLUCIONESValue;
    property DEVOLUCIONESIsNull : Boolean read GetDEVOLUCIONESIsNull write SetDEVOLUCIONESIsNull;
    property OldDEVOLUCIONES : TBcd read GetOldDEVOLUCIONESValue;
    property OldDEVOLUCIONESIsNull : Boolean read GetOldDEVOLUCIONESIsNull;
    property TOTAL : TBcd read GetTOTALValue write SetTOTALValue;
    property TOTALIsNull : Boolean read GetTOTALIsNull write SetTOTALIsNull;
    property OldTOTAL : TBcd read GetOldTOTALValue;
    property OldTOTALIsNull : Boolean read GetOldTOTALIsNull;
    property VALTERMDEV : TBcd read GetVALTERMDEVValue write SetVALTERMDEVValue;
    property VALTERMDEVIsNull : Boolean read GetVALTERMDEVIsNull write SetVALTERMDEVIsNull;
    property OldVALTERMDEV : TBcd read GetOldVALTERMDEVValue;
    property OldVALTERMDEVIsNull : Boolean read GetOldVALTERMDEVIsNull;
    property VALFINALRESC : TBcd read GetVALFINALRESCValue write SetVALFINALRESCValue;
    property VALFINALRESCIsNull : Boolean read GetVALFINALRESCIsNull write SetVALFINALRESCIsNull;
    property OldVALFINALRESC : TBcd read GetOldVALFINALRESCValue;
    property OldVALFINALRESCIsNull : Boolean read GetOldVALFINALRESCIsNull;
    property VALVEN : TBcd read GetVALVENValue write SetVALVENValue;
    property VALVENIsNull : Boolean read GetVALVENIsNull write SetVALVENIsNull;
    property OldVALVEN : TBcd read GetOldVALVENValue;
    property OldVALVENIsNull : Boolean read GetOldVALVENIsNull;
    property VALDEV : TBcd read GetVALDEVValue write SetVALDEVValue;
    property VALDEVIsNull : Boolean read GetVALDEVIsNull write SetVALDEVIsNull;
    property OldVALDEV : TBcd read GetOldVALDEVValue;
    property OldVALDEVIsNull : Boolean read GetOldVALDEVIsNull;
    property VALTOT : TBcd read GetVALTOTValue write SetVALTOTValue;
    property VALTOTIsNull : Boolean read GetVALTOTIsNull write SetVALTOTIsNull;
    property OldVALTOT : TBcd read GetOldVALTOTValue;
    property OldVALTOTIsNull : Boolean read GetOldVALTOTIsNull;

  public
    constructor Create(aBusinessProcessor: TDABusinessProcessor); override;
    destructor Destroy; override;

  end;

implementation

uses
  Variants, uROBinaryHelpers, uDAInterfaces;

{ TVentasTerminadasCrossTabBusinessProcessorRules }
constructor TVentasTerminadasCrossTabBusinessProcessorRules.Create(aBusinessProcessor: TDABusinessProcessor);
begin
  inherited;
end;

destructor TVentasTerminadasCrossTabBusinessProcessorRules.Destroy;
begin
  inherited;
end;


{ TVentasTerminadasBusinessProcessorRules }
constructor TVentasTerminadasBusinessProcessorRules.Create(aBusinessProcessor: TDABusinessProcessor);
begin
  inherited;
end;

destructor TVentasTerminadasBusinessProcessorRules.Destroy;
begin
  inherited;
end;

function TVentasTerminadasBusinessProcessorRules.GetNUMINFValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasNUMINF];
end;

function TVentasTerminadasBusinessProcessorRules.GetNUMINFIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasNUMINF]);
end;

function TVentasTerminadasBusinessProcessorRules.GetOldNUMINFValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasNUMINF];
end;

function TVentasTerminadasBusinessProcessorRules.GetOldNUMINFIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasNUMINF]);
end;

procedure TVentasTerminadasBusinessProcessorRules.SetNUMINFValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasNUMINF] := aValue;
end;

procedure TVentasTerminadasBusinessProcessorRules.SetNUMINFIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasNUMINF] := Null;
end;

function TVentasTerminadasBusinessProcessorRules.GetCLAVE1Value: TBcd;
begin
  result := GetVarDecimal(BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasCLAVE1]);
end;

function TVentasTerminadasBusinessProcessorRules.GetCLAVE1IsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasCLAVE1]);
end;

function TVentasTerminadasBusinessProcessorRules.GetOldCLAVE1Value: TBcd;
begin
  result := GetVarDecimal(BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasCLAVE1]);
end;

function TVentasTerminadasBusinessProcessorRules.GetOldCLAVE1IsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasCLAVE1]);
end;

procedure TVentasTerminadasBusinessProcessorRules.SetCLAVE1Value(const aValue: TBcd);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasCLAVE1] := BCDToVariant(aValue);
end;

procedure TVentasTerminadasBusinessProcessorRules.SetCLAVE1IsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasCLAVE1] := Null;
end;

function TVentasTerminadasBusinessProcessorRules.GetCLAVE2Value: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasCLAVE2];
end;

function TVentasTerminadasBusinessProcessorRules.GetCLAVE2IsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasCLAVE2]);
end;

function TVentasTerminadasBusinessProcessorRules.GetOldCLAVE2Value: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasCLAVE2];
end;

function TVentasTerminadasBusinessProcessorRules.GetOldCLAVE2IsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasCLAVE2]);
end;

procedure TVentasTerminadasBusinessProcessorRules.SetCLAVE2Value(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasCLAVE2] := aValue;
end;

procedure TVentasTerminadasBusinessProcessorRules.SetCLAVE2IsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasCLAVE2] := Null;
end;

function TVentasTerminadasBusinessProcessorRules.GetCLAVE3Value: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasCLAVE3];
end;

function TVentasTerminadasBusinessProcessorRules.GetCLAVE3IsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasCLAVE3]);
end;

function TVentasTerminadasBusinessProcessorRules.GetOldCLAVE3Value: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasCLAVE3];
end;

function TVentasTerminadasBusinessProcessorRules.GetOldCLAVE3IsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasCLAVE3]);
end;

procedure TVentasTerminadasBusinessProcessorRules.SetCLAVE3Value(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasCLAVE3] := aValue;
end;

procedure TVentasTerminadasBusinessProcessorRules.SetCLAVE3IsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasCLAVE3] := Null;
end;

function TVentasTerminadasBusinessProcessorRules.GetFECHAValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasFECHA];
end;

function TVentasTerminadasBusinessProcessorRules.GetFECHAIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasFECHA]);
end;

function TVentasTerminadasBusinessProcessorRules.GetOldFECHAValue: DateTime;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasFECHA];
end;

function TVentasTerminadasBusinessProcessorRules.GetOldFECHAIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasFECHA]);
end;

procedure TVentasTerminadasBusinessProcessorRules.SetFECHAValue(const aValue: DateTime);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasFECHA] := aValue;
end;

procedure TVentasTerminadasBusinessProcessorRules.SetFECHAIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasFECHA] := Null;
end;

function TVentasTerminadasBusinessProcessorRules.GetDIAValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasDIA];
end;

function TVentasTerminadasBusinessProcessorRules.GetDIAIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasDIA]);
end;

function TVentasTerminadasBusinessProcessorRules.GetOldDIAValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasDIA];
end;

function TVentasTerminadasBusinessProcessorRules.GetOldDIAIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasDIA]);
end;

procedure TVentasTerminadasBusinessProcessorRules.SetDIAValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasDIA] := aValue;
end;

procedure TVentasTerminadasBusinessProcessorRules.SetDIAIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasDIA] := Null;
end;

function TVentasTerminadasBusinessProcessorRules.GetDIASEMANAValue: WideString;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasDIASEMANA];
end;

function TVentasTerminadasBusinessProcessorRules.GetDIASEMANAIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasDIASEMANA]);
end;

function TVentasTerminadasBusinessProcessorRules.GetOldDIASEMANAValue: WideString;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasDIASEMANA];
end;

function TVentasTerminadasBusinessProcessorRules.GetOldDIASEMANAIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasDIASEMANA]);
end;

procedure TVentasTerminadasBusinessProcessorRules.SetDIASEMANAValue(const aValue: WideString);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasDIASEMANA] := aValue;
end;

procedure TVentasTerminadasBusinessProcessorRules.SetDIASEMANAIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasDIASEMANA] := Null;
end;

function TVentasTerminadasBusinessProcessorRules.GetMESValue: WideString;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasMES];
end;

function TVentasTerminadasBusinessProcessorRules.GetMESIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasMES]);
end;

function TVentasTerminadasBusinessProcessorRules.GetOldMESValue: WideString;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasMES];
end;

function TVentasTerminadasBusinessProcessorRules.GetOldMESIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasMES]);
end;

procedure TVentasTerminadasBusinessProcessorRules.SetMESValue(const aValue: WideString);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasMES] := aValue;
end;

procedure TVentasTerminadasBusinessProcessorRules.SetMESIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasMES] := Null;
end;

function TVentasTerminadasBusinessProcessorRules.GetANOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasANO];
end;

function TVentasTerminadasBusinessProcessorRules.GetANOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasANO]);
end;

function TVentasTerminadasBusinessProcessorRules.GetOldANOValue: Integer;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasANO];
end;

function TVentasTerminadasBusinessProcessorRules.GetOldANOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasANO]);
end;

procedure TVentasTerminadasBusinessProcessorRules.SetANOValue(const aValue: Integer);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasANO] := aValue;
end;

procedure TVentasTerminadasBusinessProcessorRules.SetANOIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasANO] := Null;
end;

function TVentasTerminadasBusinessProcessorRules.GetCENTROValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasCENTRO];
end;

function TVentasTerminadasBusinessProcessorRules.GetCENTROIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasCENTRO]);
end;

function TVentasTerminadasBusinessProcessorRules.GetOldCENTROValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasCENTRO];
end;

function TVentasTerminadasBusinessProcessorRules.GetOldCENTROIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasCENTRO]);
end;

procedure TVentasTerminadasBusinessProcessorRules.SetCENTROValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasCENTRO] := aValue;
end;

procedure TVentasTerminadasBusinessProcessorRules.SetCENTROIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasCENTRO] := Null;
end;

function TVentasTerminadasBusinessProcessorRules.GetVENDEDORValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasVENDEDOR];
end;

function TVentasTerminadasBusinessProcessorRules.GetVENDEDORIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasVENDEDOR]);
end;

function TVentasTerminadasBusinessProcessorRules.GetOldVENDEDORValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasVENDEDOR];
end;

function TVentasTerminadasBusinessProcessorRules.GetOldVENDEDORIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasVENDEDOR]);
end;

procedure TVentasTerminadasBusinessProcessorRules.SetVENDEDORValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasVENDEDOR] := aValue;
end;

procedure TVentasTerminadasBusinessProcessorRules.SetVENDEDORIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasVENDEDOR] := Null;
end;

function TVentasTerminadasBusinessProcessorRules.GetNUMTALONValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasNUMTALON];
end;

function TVentasTerminadasBusinessProcessorRules.GetNUMTALONIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasNUMTALON]);
end;

function TVentasTerminadasBusinessProcessorRules.GetOldNUMTALONValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasNUMTALON];
end;

function TVentasTerminadasBusinessProcessorRules.GetOldNUMTALONIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasNUMTALON]);
end;

procedure TVentasTerminadasBusinessProcessorRules.SetNUMTALONValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasNUMTALON] := aValue;
end;

procedure TVentasTerminadasBusinessProcessorRules.SetNUMTALONIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasNUMTALON] := Null;
end;

function TVentasTerminadasBusinessProcessorRules.GetCODIGOValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasCODIGO];
end;

function TVentasTerminadasBusinessProcessorRules.GetCODIGOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasCODIGO]);
end;

function TVentasTerminadasBusinessProcessorRules.GetOldCODIGOValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasCODIGO];
end;

function TVentasTerminadasBusinessProcessorRules.GetOldCODIGOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasCODIGO]);
end;

procedure TVentasTerminadasBusinessProcessorRules.SetCODIGOValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasCODIGO] := aValue;
end;

procedure TVentasTerminadasBusinessProcessorRules.SetCODIGOIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasCODIGO] := Null;
end;

function TVentasTerminadasBusinessProcessorRules.GetPRODUCTOValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasPRODUCTO];
end;

function TVentasTerminadasBusinessProcessorRules.GetPRODUCTOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasPRODUCTO]);
end;

function TVentasTerminadasBusinessProcessorRules.GetOldPRODUCTOValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasPRODUCTO];
end;

function TVentasTerminadasBusinessProcessorRules.GetOldPRODUCTOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasPRODUCTO]);
end;

procedure TVentasTerminadasBusinessProcessorRules.SetPRODUCTOValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasPRODUCTO] := aValue;
end;

procedure TVentasTerminadasBusinessProcessorRules.SetPRODUCTOIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasPRODUCTO] := Null;
end;

function TVentasTerminadasBusinessProcessorRules.GetGRUPOPRODUCTOValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasGRUPOPRODUCTO];
end;

function TVentasTerminadasBusinessProcessorRules.GetGRUPOPRODUCTOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasGRUPOPRODUCTO]);
end;

function TVentasTerminadasBusinessProcessorRules.GetOldGRUPOPRODUCTOValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasGRUPOPRODUCTO];
end;

function TVentasTerminadasBusinessProcessorRules.GetOldGRUPOPRODUCTOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasGRUPOPRODUCTO]);
end;

procedure TVentasTerminadasBusinessProcessorRules.SetGRUPOPRODUCTOValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasGRUPOPRODUCTO] := aValue;
end;

procedure TVentasTerminadasBusinessProcessorRules.SetGRUPOPRODUCTOIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasGRUPOPRODUCTO] := Null;
end;

function TVentasTerminadasBusinessProcessorRules.GetTIPOPRODUCTOValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasTIPOPRODUCTO];
end;

function TVentasTerminadasBusinessProcessorRules.GetTIPOPRODUCTOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasTIPOPRODUCTO]);
end;

function TVentasTerminadasBusinessProcessorRules.GetOldTIPOPRODUCTOValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasTIPOPRODUCTO];
end;

function TVentasTerminadasBusinessProcessorRules.GetOldTIPOPRODUCTOIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasTIPOPRODUCTO]);
end;

procedure TVentasTerminadasBusinessProcessorRules.SetTIPOPRODUCTOValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasTIPOPRODUCTO] := aValue;
end;

procedure TVentasTerminadasBusinessProcessorRules.SetTIPOPRODUCTOIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasTIPOPRODUCTO] := Null;
end;

function TVentasTerminadasBusinessProcessorRules.GetCOLECCIONValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasCOLECCION];
end;

function TVentasTerminadasBusinessProcessorRules.GetCOLECCIONIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasCOLECCION]);
end;

function TVentasTerminadasBusinessProcessorRules.GetOldCOLECCIONValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasCOLECCION];
end;

function TVentasTerminadasBusinessProcessorRules.GetOldCOLECCIONIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasCOLECCION]);
end;

procedure TVentasTerminadasBusinessProcessorRules.SetCOLECCIONValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasCOLECCION] := aValue;
end;

procedure TVentasTerminadasBusinessProcessorRules.SetCOLECCIONIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasCOLECCION] := Null;
end;

function TVentasTerminadasBusinessProcessorRules.GetCOLORValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasCOLOR];
end;

function TVentasTerminadasBusinessProcessorRules.GetCOLORIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasCOLOR]);
end;

function TVentasTerminadasBusinessProcessorRules.GetOldCOLORValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasCOLOR];
end;

function TVentasTerminadasBusinessProcessorRules.GetOldCOLORIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasCOLOR]);
end;

procedure TVentasTerminadasBusinessProcessorRules.SetCOLORValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasCOLOR] := aValue;
end;

procedure TVentasTerminadasBusinessProcessorRules.SetCOLORIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasCOLOR] := Null;
end;

function TVentasTerminadasBusinessProcessorRules.GetTALLAValue: String;
begin
  result := BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasTALLA];
end;

function TVentasTerminadasBusinessProcessorRules.GetTALLAIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasTALLA]);
end;

function TVentasTerminadasBusinessProcessorRules.GetOldTALLAValue: String;
begin
  result := BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasTALLA];
end;

function TVentasTerminadasBusinessProcessorRules.GetOldTALLAIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasTALLA]);
end;

procedure TVentasTerminadasBusinessProcessorRules.SetTALLAValue(const aValue: String);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasTALLA] := aValue;
end;

procedure TVentasTerminadasBusinessProcessorRules.SetTALLAIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasTALLA] := Null;
end;

function TVentasTerminadasBusinessProcessorRules.GetTALLA38Value: TBcd;
begin
  result := GetVarDecimal(BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasTALLA38]);
end;

function TVentasTerminadasBusinessProcessorRules.GetTALLA38IsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasTALLA38]);
end;

function TVentasTerminadasBusinessProcessorRules.GetOldTALLA38Value: TBcd;
begin
  result := GetVarDecimal(BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasTALLA38]);
end;

function TVentasTerminadasBusinessProcessorRules.GetOldTALLA38IsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasTALLA38]);
end;

procedure TVentasTerminadasBusinessProcessorRules.SetTALLA38Value(const aValue: TBcd);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasTALLA38] := BCDToVariant(aValue);
end;

procedure TVentasTerminadasBusinessProcessorRules.SetTALLA38IsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasTALLA38] := Null;
end;

function TVentasTerminadasBusinessProcessorRules.GetTALLA40Value: TBcd;
begin
  result := GetVarDecimal(BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasTALLA40]);
end;

function TVentasTerminadasBusinessProcessorRules.GetTALLA40IsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasTALLA40]);
end;

function TVentasTerminadasBusinessProcessorRules.GetOldTALLA40Value: TBcd;
begin
  result := GetVarDecimal(BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasTALLA40]);
end;

function TVentasTerminadasBusinessProcessorRules.GetOldTALLA40IsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasTALLA40]);
end;

procedure TVentasTerminadasBusinessProcessorRules.SetTALLA40Value(const aValue: TBcd);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasTALLA40] := BCDToVariant(aValue);
end;

procedure TVentasTerminadasBusinessProcessorRules.SetTALLA40IsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasTALLA40] := Null;
end;

function TVentasTerminadasBusinessProcessorRules.GetTALLA42Value: TBcd;
begin
  result := GetVarDecimal(BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasTALLA42]);
end;

function TVentasTerminadasBusinessProcessorRules.GetTALLA42IsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasTALLA42]);
end;

function TVentasTerminadasBusinessProcessorRules.GetOldTALLA42Value: TBcd;
begin
  result := GetVarDecimal(BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasTALLA42]);
end;

function TVentasTerminadasBusinessProcessorRules.GetOldTALLA42IsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasTALLA42]);
end;

procedure TVentasTerminadasBusinessProcessorRules.SetTALLA42Value(const aValue: TBcd);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasTALLA42] := BCDToVariant(aValue);
end;

procedure TVentasTerminadasBusinessProcessorRules.SetTALLA42IsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasTALLA42] := Null;
end;

function TVentasTerminadasBusinessProcessorRules.GetTALLA44Value: TBcd;
begin
  result := GetVarDecimal(BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasTALLA44]);
end;

function TVentasTerminadasBusinessProcessorRules.GetTALLA44IsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasTALLA44]);
end;

function TVentasTerminadasBusinessProcessorRules.GetOldTALLA44Value: TBcd;
begin
  result := GetVarDecimal(BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasTALLA44]);
end;

function TVentasTerminadasBusinessProcessorRules.GetOldTALLA44IsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasTALLA44]);
end;

procedure TVentasTerminadasBusinessProcessorRules.SetTALLA44Value(const aValue: TBcd);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasTALLA44] := BCDToVariant(aValue);
end;

procedure TVentasTerminadasBusinessProcessorRules.SetTALLA44IsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasTALLA44] := Null;
end;

function TVentasTerminadasBusinessProcessorRules.GetTALLA46Value: TBcd;
begin
  result := GetVarDecimal(BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasTALLA46]);
end;

function TVentasTerminadasBusinessProcessorRules.GetTALLA46IsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasTALLA46]);
end;

function TVentasTerminadasBusinessProcessorRules.GetOldTALLA46Value: TBcd;
begin
  result := GetVarDecimal(BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasTALLA46]);
end;

function TVentasTerminadasBusinessProcessorRules.GetOldTALLA46IsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasTALLA46]);
end;

procedure TVentasTerminadasBusinessProcessorRules.SetTALLA46Value(const aValue: TBcd);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasTALLA46] := BCDToVariant(aValue);
end;

procedure TVentasTerminadasBusinessProcessorRules.SetTALLA46IsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasTALLA46] := Null;
end;

function TVentasTerminadasBusinessProcessorRules.GetTALLA48Value: TBcd;
begin
  result := GetVarDecimal(BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasTALLA48]);
end;

function TVentasTerminadasBusinessProcessorRules.GetTALLA48IsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasTALLA48]);
end;

function TVentasTerminadasBusinessProcessorRules.GetOldTALLA48Value: TBcd;
begin
  result := GetVarDecimal(BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasTALLA48]);
end;

function TVentasTerminadasBusinessProcessorRules.GetOldTALLA48IsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasTALLA48]);
end;

procedure TVentasTerminadasBusinessProcessorRules.SetTALLA48Value(const aValue: TBcd);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasTALLA48] := BCDToVariant(aValue);
end;

procedure TVentasTerminadasBusinessProcessorRules.SetTALLA48IsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasTALLA48] := Null;
end;

function TVentasTerminadasBusinessProcessorRules.GetVTATERMDEVValue: TBcd;
begin
  result := GetVarDecimal(BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasVTATERMDEV]);
end;

function TVentasTerminadasBusinessProcessorRules.GetVTATERMDEVIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasVTATERMDEV]);
end;

function TVentasTerminadasBusinessProcessorRules.GetOldVTATERMDEVValue: TBcd;
begin
  result := GetVarDecimal(BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasVTATERMDEV]);
end;

function TVentasTerminadasBusinessProcessorRules.GetOldVTATERMDEVIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasVTATERMDEV]);
end;

procedure TVentasTerminadasBusinessProcessorRules.SetVTATERMDEVValue(const aValue: TBcd);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasVTATERMDEV] := BCDToVariant(aValue);
end;

procedure TVentasTerminadasBusinessProcessorRules.SetVTATERMDEVIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasVTATERMDEV] := Null;
end;

function TVentasTerminadasBusinessProcessorRules.GetVTAFINALRESCValue: TBcd;
begin
  result := GetVarDecimal(BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasVTAFINALRESC]);
end;

function TVentasTerminadasBusinessProcessorRules.GetVTAFINALRESCIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasVTAFINALRESC]);
end;

function TVentasTerminadasBusinessProcessorRules.GetOldVTAFINALRESCValue: TBcd;
begin
  result := GetVarDecimal(BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasVTAFINALRESC]);
end;

function TVentasTerminadasBusinessProcessorRules.GetOldVTAFINALRESCIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasVTAFINALRESC]);
end;

procedure TVentasTerminadasBusinessProcessorRules.SetVTAFINALRESCValue(const aValue: TBcd);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasVTAFINALRESC] := BCDToVariant(aValue);
end;

procedure TVentasTerminadasBusinessProcessorRules.SetVTAFINALRESCIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasVTAFINALRESC] := Null;
end;

function TVentasTerminadasBusinessProcessorRules.GetVENTASValue: TBcd;
begin
  result := GetVarDecimal(BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasVENTAS]);
end;

function TVentasTerminadasBusinessProcessorRules.GetVENTASIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasVENTAS]);
end;

function TVentasTerminadasBusinessProcessorRules.GetOldVENTASValue: TBcd;
begin
  result := GetVarDecimal(BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasVENTAS]);
end;

function TVentasTerminadasBusinessProcessorRules.GetOldVENTASIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasVENTAS]);
end;

procedure TVentasTerminadasBusinessProcessorRules.SetVENTASValue(const aValue: TBcd);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasVENTAS] := BCDToVariant(aValue);
end;

procedure TVentasTerminadasBusinessProcessorRules.SetVENTASIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasVENTAS] := Null;
end;

function TVentasTerminadasBusinessProcessorRules.GetDEVOLUCIONESValue: TBcd;
begin
  result := GetVarDecimal(BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasDEVOLUCIONES]);
end;

function TVentasTerminadasBusinessProcessorRules.GetDEVOLUCIONESIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasDEVOLUCIONES]);
end;

function TVentasTerminadasBusinessProcessorRules.GetOldDEVOLUCIONESValue: TBcd;
begin
  result := GetVarDecimal(BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasDEVOLUCIONES]);
end;

function TVentasTerminadasBusinessProcessorRules.GetOldDEVOLUCIONESIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasDEVOLUCIONES]);
end;

procedure TVentasTerminadasBusinessProcessorRules.SetDEVOLUCIONESValue(const aValue: TBcd);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasDEVOLUCIONES] := BCDToVariant(aValue);
end;

procedure TVentasTerminadasBusinessProcessorRules.SetDEVOLUCIONESIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasDEVOLUCIONES] := Null;
end;

function TVentasTerminadasBusinessProcessorRules.GetTOTALValue: TBcd;
begin
  result := GetVarDecimal(BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasTOTAL]);
end;

function TVentasTerminadasBusinessProcessorRules.GetTOTALIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasTOTAL]);
end;

function TVentasTerminadasBusinessProcessorRules.GetOldTOTALValue: TBcd;
begin
  result := GetVarDecimal(BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasTOTAL]);
end;

function TVentasTerminadasBusinessProcessorRules.GetOldTOTALIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasTOTAL]);
end;

procedure TVentasTerminadasBusinessProcessorRules.SetTOTALValue(const aValue: TBcd);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasTOTAL] := BCDToVariant(aValue);
end;

procedure TVentasTerminadasBusinessProcessorRules.SetTOTALIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasTOTAL] := Null;
end;

function TVentasTerminadasBusinessProcessorRules.GetVALTERMDEVValue: TBcd;
begin
  result := GetVarDecimal(BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasVALTERMDEV]);
end;

function TVentasTerminadasBusinessProcessorRules.GetVALTERMDEVIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasVALTERMDEV]);
end;

function TVentasTerminadasBusinessProcessorRules.GetOldVALTERMDEVValue: TBcd;
begin
  result := GetVarDecimal(BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasVALTERMDEV]);
end;

function TVentasTerminadasBusinessProcessorRules.GetOldVALTERMDEVIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasVALTERMDEV]);
end;

procedure TVentasTerminadasBusinessProcessorRules.SetVALTERMDEVValue(const aValue: TBcd);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasVALTERMDEV] := BCDToVariant(aValue);
end;

procedure TVentasTerminadasBusinessProcessorRules.SetVALTERMDEVIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasVALTERMDEV] := Null;
end;

function TVentasTerminadasBusinessProcessorRules.GetVALFINALRESCValue: TBcd;
begin
  result := GetVarDecimal(BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasVALFINALRESC]);
end;

function TVentasTerminadasBusinessProcessorRules.GetVALFINALRESCIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasVALFINALRESC]);
end;

function TVentasTerminadasBusinessProcessorRules.GetOldVALFINALRESCValue: TBcd;
begin
  result := GetVarDecimal(BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasVALFINALRESC]);
end;

function TVentasTerminadasBusinessProcessorRules.GetOldVALFINALRESCIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasVALFINALRESC]);
end;

procedure TVentasTerminadasBusinessProcessorRules.SetVALFINALRESCValue(const aValue: TBcd);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasVALFINALRESC] := BCDToVariant(aValue);
end;

procedure TVentasTerminadasBusinessProcessorRules.SetVALFINALRESCIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasVALFINALRESC] := Null;
end;

function TVentasTerminadasBusinessProcessorRules.GetVALVENValue: TBcd;
begin
  result := GetVarDecimal(BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasVALVEN]);
end;

function TVentasTerminadasBusinessProcessorRules.GetVALVENIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasVALVEN]);
end;

function TVentasTerminadasBusinessProcessorRules.GetOldVALVENValue: TBcd;
begin
  result := GetVarDecimal(BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasVALVEN]);
end;

function TVentasTerminadasBusinessProcessorRules.GetOldVALVENIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasVALVEN]);
end;

procedure TVentasTerminadasBusinessProcessorRules.SetVALVENValue(const aValue: TBcd);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasVALVEN] := BCDToVariant(aValue);
end;

procedure TVentasTerminadasBusinessProcessorRules.SetVALVENIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasVALVEN] := Null;
end;

function TVentasTerminadasBusinessProcessorRules.GetVALDEVValue: TBcd;
begin
  result := GetVarDecimal(BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasVALDEV]);
end;

function TVentasTerminadasBusinessProcessorRules.GetVALDEVIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasVALDEV]);
end;

function TVentasTerminadasBusinessProcessorRules.GetOldVALDEVValue: TBcd;
begin
  result := GetVarDecimal(BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasVALDEV]);
end;

function TVentasTerminadasBusinessProcessorRules.GetOldVALDEVIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasVALDEV]);
end;

procedure TVentasTerminadasBusinessProcessorRules.SetVALDEVValue(const aValue: TBcd);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasVALDEV] := BCDToVariant(aValue);
end;

procedure TVentasTerminadasBusinessProcessorRules.SetVALDEVIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasVALDEV] := Null;
end;

function TVentasTerminadasBusinessProcessorRules.GetVALTOTValue: TBcd;
begin
  result := GetVarDecimal(BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasVALTOT]);
end;

function TVentasTerminadasBusinessProcessorRules.GetVALTOTIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasVALTOT]);
end;

function TVentasTerminadasBusinessProcessorRules.GetOldVALTOTValue: TBcd;
begin
  result := GetVarDecimal(BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasVALTOT]);
end;

function TVentasTerminadasBusinessProcessorRules.GetOldVALTOTIsNull: Boolean;
begin
  result := VarIsNull(BusinessProcessor.CurrentChange.OldValueByName[fld_VentasTerminadasVALTOT]);
end;

procedure TVentasTerminadasBusinessProcessorRules.SetVALTOTValue(const aValue: TBcd);
begin
  BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasVALTOT] := BCDToVariant(aValue);
end;

procedure TVentasTerminadasBusinessProcessorRules.SetVALTOTIsNull(const aValue: Boolean);
begin
  if aValue then
    BusinessProcessor.CurrentChange.NewValueByName[fld_VentasTerminadasVALTOT] := Null;
end;


initialization
  RegisterBusinessProcessorRules(RID_VentasTerminadasCrossTabDelta, TVentasTerminadasCrossTabBusinessProcessorRules);
  RegisterBusinessProcessorRules(RID_VentasTerminadasDelta, TVentasTerminadasBusinessProcessorRules);

end.
